//
// --------------------------------------------------------
// CQoŊ ĊwCANʐM
//   copyright(c) 2010 T.Nakao All rights reserved.
// --------------------------------------------------------
//
//
// MCP2515 CANhCo (CCSC/WinAVR)
// 		copyright (c) 2008,2009 T.Nakao
//
// 	09/01/12
//

typedef unsigned int WORD;
typedef unsigned char BYTE;

// SPI|[g rbg
#define CAN_SPI_CS_H	CAN_SPI_CS_PORT|=(1<<CAN_SPI_CS_BIT)
#define CAN_SPI_SO_H	CAN_SPI_SO_PORT|=(1<<CAN_SPI_SO_BIT)
#define CAN_SPI_SCK_H	CAN_SPI_SCK_PORT|=(1<<CAN_SPI_SCK_BIT)

#define CAN_SPI_CS_L	CAN_SPI_CS_PORT&=~(1<<CAN_SPI_CS_BIT)
#define CAN_SPI_SO_L	CAN_SPI_SO_PORT&=~(1<<CAN_SPI_SO_BIT)
#define CAN_SPI_SCK_L	CAN_SPI_SCK_PORT&=~(1<<CAN_SPI_SCK_BIT)

#define CAN_SPI_SI		(CAN_SPI_SI_PORT&(1<<CAN_SPI_SI_BIT))


// CANrbg[g [Xs[h 125KHz
#define CAN_BRP_20MHz_125BPS	4			// FOSC=20MHz
#define CAN_BRP_16MHz_125BPS	3			// FOSC=16MHz
#define CAN_BRP_8MHz_125BPS		2			// FOSC=8MHz


// SPIR}h CXgNV
#define SPI_INST_RESET		0xC0
#define SPI_INST_READ		0x03
#define SPI_INST_WRITE		0x02
#define SPI_INST_RD_RXBUF	0xC0
#define SPI_INST_LD_TXBUF	0x40
#define SPI_INST_RTS		0x80
#define SPI_INST_RD_STAT	0xA0
#define SPI_INST_RX_STAT	0xB0
#define SPI_INST_BIT_MOD	0x05

// ^Mobt@ V[PVE[h^Cg CXgNV
#define RD_RXBUF_RXB0SIDH	0x90
#define RD_RXBUF_RXB0D0		0x92
#define RD_RXBUF_RXB1SIDH	0x94
#define RD_RXBUF_RXB1D0		0x96
#define LD_TXBUF_TXB0SIDH	0x40
#define LD_TXBUF_TXB0D0		0x41
#define LD_TXBUF_TXB1SIDH	0x42
#define LD_TXBUF_TXB1D0		0x43
#define LD_TXBUF_TXB2SIDH	0x44
#define LD_TXBUF_TXB2D0		0x45

// *********** CAN hCoi}Nj ************

// CANIy[VE[hݒ
#define CANSetOpMode(mode) CANBitModCmd(CANCTRL, 7<<5, mode<<5)
// Iy[VE[h CANCTRL/CANSTAT
#define CAM_MODE_NORMAL		0
#define CAM_MODE_SLEEP		1
#define CAM_MODE_LOOPBACK	2
#define CAM_MODE_LISTEN		3
#define CAM_MODE_CONFIG		4


// WX^ oCgE[h
#define CANReadReg(adrs) CANRegRead2B(SPI_INST_READ, adrs)

// Xe[^XE[h
#define CANReadStat() CANRegRead2B(SPI_INST_RD_STAT, 0)

// MXe[^XE[h
#define CANReadRXStat() CANRegRead2B(SPI_INST_RX_STAT, 0)

// tB^E[h̐ݒ
#define CANSetFilterRxB0(mode) CANWriteReg(RXB0CTRL, mode<<5)
#define CANSetFilterRxB1(mode) CANWriteReg(RXB1CTRL, mode<<5)
// mode
#define FILTER_MOD_ALL_HIT 3		// }XNAtB^gp
#define FILTER_MOD_SID_HIT 1		// SIDŃ}XNAtB^Kp


// Mobt@ V[PVE[h
#define CANRxB0MsgRead(buf) CANTxRxBufRW(RD_RXBUF_RXB0SIDH, 1, buf, 5)
#define CANRxB1MsgRead(buf) CANTxRxBufRW(RD_RXBUF_RXB1SIDH, 1, buf, 5)
#define CANRxB0DatRead(buf) CANTxRxBufRW(RD_RXBUF_RXB0D0, 1, buf, 8)
#define CANRxB1DatRead(buf) CANTxRxBufRW(RD_RXBUF_RXB1D0, 1, buf, 8)

// Mobt@ V[PVE[h(bZ[W{f[^)
#define CANRxB0Read(buf, dsiz) CANTxRxBufRW(RD_RXBUF_RXB0SIDH, 1, buf, 5+dsiz)
#define CANRxB1Read(buf, dsiz) CANTxRxBufRW(RD_RXBUF_RXB1SIDH, 1, buf, 5+dsiz)


// Mobt@ V[PVECg
#define CANTxB0MsgWrite(buf) CANTxRxBufRW(LD_TXBUF_TXB0SIDH, 0, buf, 5)
#define CANTxB1MsgWrite(buf) CANTxRxBufRW(LD_TXBUF_TXB1SIDH, 0, buf, 5)
#define CANTxB2MsgWrite(buf) CANTxRxBufRW(LD_TXBUF_TXB2SIDH, 0, buf, 5)
#define CANTxB0DatWrite(buf) CANTxRxBufRW(LD_TXBUF_TXB0D0, 0, buf, 8)
#define CANTxB1DatWrite(buf) CANTxRxBufRW(LD_TXBUF_TXB1D0, 0, buf, 8)
#define CANTxB2DatWrite(buf) CANTxRxBufRW(LD_TXBUF_TXB2D0, 0, buf, 8)

// Mobt@ V[PVECg(bZ[W{f[^)
#define CANTxB0Write(buf, dsiz) CANTxRxBufRW(LD_TXBUF_TXB0SIDH, 0, buf, 5+dsiz)
#define CANTxB1Write(buf, dsiz) CANTxRxBufRW(LD_TXBUF_TXB1SIDH, 0, buf, 5+dsiz)
#define CANTxB2Write(buf, dsiz) CANTxRxBufRW(LD_TXBUF_TXB2SIDH, 0, buf, 5+dsiz)


// tB^SIDݒ
#define CANSetSidFilter0(sid) CANSetSidFilteMask(RXF0SIDH, sid)
#define CANSetSidFilter1(sid) CANSetSidFilteMask(RXF1SIDH, sid)
#define CANSetSidFilter2(sid) CANSetSidFilteMask(RXF2SIDH, sid)
#define CANSetSidFilter3(sid) CANSetSidFilteMask(RXF3SIDH, sid)
#define CANSetSidFilter4(sid) CANSetSidFilteMask(RXF4SIDH, sid)
#define CANSetSidFilter5(sid) CANSetSidFilteMask(RXF5SIDH, sid)

// }XNSIDݒ
#define CANSetSidMask0(sid) CANSetSidFilteMask(RXM0SIDH, sid)
#define CANSetSidMask1(sid) CANSetSidFilteMask(RXM1SIDH, sid)
// sid
#define MASK_SID_ALL_HIT   0x0000		// ׂă}XN
#define MASK_SID_CPL_MATCH 0x07FF		// }XN Sv

// SIDWX^l}N
#define GET_SIDH(msg) (BYTE)(msg >> 3)
#define GET_SIDL(msg) (BYTE)(msg << 5)
#define MAKE_SID(sid_h, sid_l) ((WORD)sid_h<<3)|(sid_l>>5)


// SPIR}h MXe[^X\(MXe[^XE[hER}h)
struct tag_RXSTAT {
	unsigned char FilterMatch:3;		// b0-b2 qbgtB^̔ԍ
	unsigned char RemoteFrm:1;		// b3 (1)[gEt[/(0)f[^Et[
	unsigned char ExtMsg:1;			// b4 (1)gID/(0)WID
	unsigned char b5:1;				// b5
	unsigned char MsgInRXB0:1;		// b6 RXB0ɃbZ[W
	unsigned char MsgInRXB1:1;		// b7 RXB1ɃbZ[W
};

enum t_RXSTAT {
	FilterMatch0 = 0,		// b0 qbgtB^̔ԍ
	FilterMatch1 = 1,		// b1 qbgtB^̔ԍ
	FilterMatch2 = 2,		// b2 qbgtB^̔ԍ
	RemoteFrm = 3,			// b3 (1)[gEt[/(0)f[^Et[
	ExtMsg = 4,				// b4 (1)gID/(0)WID
//	b5 = 5,					// b5
	MsgInRXB0 = 6,			// b6 RXB0ɃbZ[W
	MsgInRXB1 = 7,			// b7 RXB1ɃbZ[W
};


// vg^Cv
void CANInit(BYTE brp);
BYTE CANRxCheck(BYTE rxbnum);
void CANReset(void);
void CANWriteReg(BYTE adrs, BYTE data);
BYTE CANRegRead2B(BYTE inst, BYTE adrs);
void CANSetSidFilteMask(BYTE adrs, WORD sid);
void CANBitModCmd(BYTE adrs, BYTE mask, BYTE data);
void CANTxRxBufRW(BYTE inst, BYTE readop, BYTE *data, BYTE cnt);


// --------------------------------------------------------------------
//
// --------------------------------------------------------------------
void CANInit(BYTE brp) {
	struct tag_CNF1 *p_cnf1;
	struct tag_CNF2 *p_cnf2;
	struct tag_CNF3 *p_cnf3;
	BYTE reg;

	// SPI|[g̏
	CAN_SPI_CS_DDR |= (1<<CAN_SPI_CS_BIT);		// output
	CAN_SPI_SO_DDR |= (1<<CAN_SPI_SO_BIT);		// output
	CAN_SPI_SCK_DDR |= (1<<CAN_SPI_SCK_BIT);	// output
	CAN_SPI_SI_DDR &= ~(1<<CAN_SPI_SI_BIT);		// input

	// SPIoX ACh
	CAN_SPI_CS_H;
	CAN_SPI_SCK_L;

	_delay_ms(10);
	CANReset();

	_delay_ms(10);
	CANBitModCmd(BFPCTRL, (1<<B0BFS) | (1<<B0BFE), (1<<B0BFS) | (1<<B0BFE));		// LED3 ON
//	CANWriteReg(BFPCTRL, (1<<B0BFS) | (1<<B0BFE));
//	CANWriteReg(BFPCTRL, 0x14);

	CANSetOpMode(CAM_MODE_CONFIG);
	// MCP2515 RtBM[Vݒ
	// {[[gݒ 125kbps (X=20MHz)
	// Tq = (2 x (BRP + 1))/Fosc )
	reg = 0;
	p_cnf1 = (struct tag_CNF1 *)&reg;
	p_cnf1->BRP = brp;					// 1/10
	p_cnf1->SJW0 = 0;
	p_cnf1->SJW1 = 0;
	CANWriteReg(CAN_CNF1, reg);

	reg = 0;
	p_cnf2 = (struct tag_CNF2 *)&reg;
	p_cnf2->PRSEG = 1;					// ProgSeg = 2
	p_cnf2->PHSEG1 = 6;				// PH1 = 7
	p_cnf2->SAM = 0;
	p_cnf2->BTLMODE = 1;
	CANWriteReg(CAN_CNF2, reg);

	reg = 0;
	p_cnf3 = (struct tag_CNF3 *)&reg;
	p_cnf3->PHSEG2 = 5;				// PH2 = 6
	p_cnf3->WAKFIL = 0;
	p_cnf3->SOF = 0;
	CANWriteReg(CAN_CNF3, reg);

//		CANSetOpMode(CAM_MODE_NORMAL);

}


// --------------------------------------------------------------------
// CANM`FbN
// --------------------------------------------------------------------
BYTE CANRxCheck(BYTE rxbnum) {
	BYTE rxstat;

	rxstat = CANReadRXStat();			// MXe[^X擾

	if(rxbnum == 0) {
		return rxstat & 1<<MsgInRXB0;
	} else if(rxbnum == 1) {
		return rxstat & 1<<MsgInRXB1;
	}

	return rxstat & ( (1<<MsgInRXB0) | (1<<MsgInRXB1) );
}


// --------------------------------------------------------------------
// CANZbg
// --------------------------------------------------------------------
void CANReset(void) {
	BYTE i;
	BYTE cmd = SPI_INST_RESET;

	CAN_SPI_CS_L;

	for(i = 0; i < 8; i++) {
		if(cmd & 0x80) {
			// 1
			CAN_SPI_SO_H;
		} else {
			// 0
			CAN_SPI_SO_L;
		}
		cmd <<= 1;
		CAN_SPI_SCK_H;		// SCK pXo
		CAN_SPI_SCK_L;
	}

	CAN_SPI_CS_H;
}


// --------------------------------------------------------------------
// CANWX^ oCgECg
// --------------------------------------------------------------------
void CANWriteReg(BYTE adrs, BYTE data) {

	BYTE cmdbf[3], cmd;
	BYTE p, i;

	cmdbf[0] = SPI_INST_WRITE;		// oCgECg
	cmdbf[1] = adrs;
	cmdbf[2] = data;

	CAN_SPI_CS_L;

	for(p = 0; p < 3; p++) {
		cmd = cmdbf[p];
		for(i = 0; i < 8; i++) {
			if(cmd & 0x80) {
				// 1
				CAN_SPI_SO_H;
			} else {
				// 0
				CAN_SPI_SO_L;
			}
			cmd <<= 1;
			CAN_SPI_SCK_H;		// SCK pXo
			CAN_SPI_SCK_L;
		}
	}

	CAN_SPI_CS_H;
}


// --------------------------------------------------------------------
// CANWX^E[h
// Xe[^XE[h
// MXe[^XE[h  (3@\p[`)
// --------------------------------------------------------------------
BYTE CANRegRead2B(BYTE inst, BYTE adrs) {
	BYTE cmdbf[2], cmd;
	BYTE p, i, dat;

	cmdbf[0] = inst;		// CXgNV
	cmdbf[1] = adrs;

	CAN_SPI_CS_L;

	// 2oCgo(f[^͖͂)
	for(p = 0; p < 2; p++) {
		cmd = cmdbf[p];
		for(i = 0; i < 8; i++) {
			if(cmd & 0x80) {
				// 1
				CAN_SPI_SO_H;
			} else {
				// 0
				CAN_SPI_SO_L;
			}
			cmd <<= 1;
			CAN_SPI_SCK_H;		// SCK pXo
			CAN_SPI_SCK_L;
		}
	}

	// f[^(Xe[^X̏ꍇ́A2ڂ̃s[gf[^)
	dat = 0;
	for(i = 0; i < 8; i++) {
		dat <<= 1;
		if(CAN_SPI_SI) {
			// 1
			dat |= 1;
		}
		CAN_SPI_SCK_H;		// SCK pXo
		CAN_SPI_SCK_L;
	}

	CAN_SPI_CS_H;

	return dat;
}


#ifndef CANSetSidFilteMask
// --------------------------------------------------------------------
// CAN SID tB^A}XNݒ (p[`)
// --------------------------------------------------------------------
void CANSetSidFilteMask(BYTE adrs, WORD sid) {
	CANWriteReg(adrs, (BYTE)(sid>>3));			// HIGH
	CANWriteReg(adrs + 1, (BYTE)(sid<<5));		// LOW
}
#endif


// --------------------------------------------------------------------
// CANrbgEft@CER}h
// --------------------------------------------------------------------
void CANBitModCmd(BYTE adrs, BYTE mask, BYTE data) {
	BYTE cmdbf[4], cmd;
	BYTE p, i;

	cmdbf[0] = SPI_INST_BIT_MOD;		// rbgEft@C
	cmdbf[1] = adrs;
	cmdbf[2] = mask;
	cmdbf[3] = data;

	CAN_SPI_CS_L;

	for(p = 0; p < 4; p++) {
		cmd = cmdbf[p];
		for(i = 0; i < 8; i++) {
			if(cmd & 0x80) {
				// 1
				CAN_SPI_SO_H;
			} else {
				// 0
				CAN_SPI_SO_L;
			}
			cmd <<= 1;
			CAN_SPI_SCK_H;		// SCK pXo
			CAN_SPI_SCK_L;
		}
	}
	CAN_SPI_CS_H;
}


// --------------------------------------------------------------------
// CAN^Mobt@ V[PVE[h^Cg (p[`)
// --------------------------------------------------------------------
void CANTxRxBufRW(BYTE inst, BYTE readop, BYTE *data, BYTE cnt) {

	BYTE dat;
	BYTE p, i;

	CAN_SPI_CS_L;

	// CXgNV̑M
	dat = inst;
	for(i = 0; i < 8; i++) {
		if(dat & 0x80) {
			// 1
			CAN_SPI_SO_H;
		} else {
			// 0
			CAN_SPI_SO_L;
		}
		dat <<= 1;
		CAN_SPI_SCK_H;		// SCK pXo
		CAN_SPI_SCK_L;
	}

	// =============== M/Mobt@ȇM =================
	if(readop) {
		// f[^M
		for(p = 0; p < cnt; p++) {
			dat = 0;
			for(i = 0; i < 8; i++) {
				dat <<= 1;
				if(CAN_SPI_SI) {
					// 1
					dat |= 1;
				}
				CAN_SPI_SCK_H;		// SCK pXo
				CAN_SPI_SCK_L;
			}
			data[p] = dat;
		}
	} else {
		// f[^M
		for(p = 0; p < cnt; p++) {
			dat = data[p];
			for(i = 0; i < 8; i++) {
				if(dat & 0x80) {
					// 1
					CAN_SPI_SO_H;
				} else {
					// 0
					CAN_SPI_SO_L;
				}
				dat <<= 1;
				CAN_SPI_SCK_H;		// SCK pXo
				CAN_SPI_SCK_L;
			}
		}
	}

	CAN_SPI_CS_H;

	return;
}

