//
// --------------------------------------------------------
// CQoŊ ĊwCANʐM
//   copyright(c) 2010 T.Nakao All rights reserved.
// --------------------------------------------------------
//
//
//	LCDhCo
//		07/02/16 AZu[`C֕ϊ
//		09/01/18
//		09/01/21 for AVR
//

#ifdef LCD_DATA_UPPBYTE
  #define LCD_DATA_MASK 0xF0		// LCDf[^4bit b7-b4
#else
  #define LCD_DATA_MASK 0x0F		// LCDf[^4bit b3-b0
#endif

// LCD f[^|[go͐ؑ(AVR)
#define LCD_DATA_INPUT LCD_DATA_TRIS&=~LCD_DATA_MASK	// LCD-DB input
#define LCD_DATA_OUTPUT LCD_DATA_TRIS|=LCD_DATA_MASK	// LCD-DB output

// LCD Rg[M
#define LCD_RS_1 LCD_RS_PORT|=(1<<LCD_RS_BIT)
#define LCD_RS_0 LCD_RS_PORT&=~(1<<LCD_RS_BIT)
#define LCD_RW_1 LCD_RW_PORT|=(1<<LCD_RW_BIT)
#define LCD_RW_0 LCD_RW_PORT&=~(1<<LCD_RW_BIT)
#define LCD_E_1  LCD_E_PORT|=(1<<LCD_E_BIT)
#define LCD_E_0  LCD_E_PORT&=~(1<<LCD_E_BIT)
// ----------------------------------------

// LCD\NA
#define LCDClear() LCDWriteData(0,0x01)

// LCD1o
#define LCDPutc(ch) LCDWriteData(1,ch)

// WIZ-C݊
#define LCDPrintAt(x,y) LCDGotoXY(x,y)

// EFCg
#define Wait1Cycle() asm volatile("NOP"::)
#define Wait(n) _delay_ms(n)

// vg^Cv
void LCDInit(void);
void LCDWrite4Bit(BYTE dat);
void LCDWriteData(BYTE rs, BYTE dat);
void LCDWaitReady(void);
void LCDGotoXY(BYTE x, BYTE y);
void LCDString(char *str);
BYTE LCDBusyCheck(void);


// LCDCXgNV
BYTE LCDIntiData[4] = {0x28, 0x0C, 0x01, 0x06};


//***********************************************
// LCD
//***********************************************
void LCDInit(void) {
	BYTE i;

	LCD_DATA_OUTPUT;				// LCDf[^|[g o
	LCD_E_TRIS |= (1<<LCD_E_BIT);
	LCD_RS_TRIS |= (1<<LCD_RS_BIT);
	LCD_RW_TRIS |= (1<<LCD_RW_BIT);

	LCD_E_0;
	LCD_RS_0;						// Registor
	LCD_RW_0;						// Write

	Wait(15);						// delay 15ms

	for(i = 0; i < 3; i++) {
		LCDWrite4Bit(0x03);
		Wait(5);
	}

	LCDWrite4Bit(0x02);

	Wait(5);

	for(i = 0; i < 4; i++) {
		LCDWriteData(0, LCDIntiData[i]);
	}
}



//***********************************************
// 4rbg
//***********************************************
void LCDWrite4Bit(BYTE dat) {
//	LED_DIS;
	BYTE pbuf;

	pbuf = LCD_DATA_PORT_IN;

#ifdef LCD_DATA_UPPBYTE
	dat <<= 4;
#endif
	pbuf &= ~LCD_DATA_MASK;				// f[^rbgNA
	pbuf |= (dat & LCD_DATA_MASK);

	LCD_DATA_PORT_OUT = pbuf;				// 4rbgo
	Wait1Cycle();
	LCD_E_1;							// E Pulse
	Wait1Cycle();
	LCD_E_0;
//	Update();

}


//***********************************************
// LCDf[^/WX^
//***********************************************
void LCDWriteData(BYTE rs, BYTE dat) {
	LCDWaitReady();				// BUSY check

	if(rs == 0) {
		// WX^ZNg
		LCD_RS_0;

	} else {
		// f[^ZNg
		LCD_RS_1;
	}

	Wait1Cycle();

	LCD_RW_0;							// Write
	Wait1Cycle();
	LCD_E_0;

	LCDWrite4Bit(dat >> 4);				// LCD D7-D4
	LCDWrite4Bit(dat);					// LCD D3-D0
}


//***********************************************
// LCD Ready҂
//	BUSŶƂ[v
//***********************************************
void LCDWaitReady(void) {
	BYTE pbuf;

	LCD_DATA_INPUT;					// LCD-DB input

	LCD_RS_0;
	do {
		LCD_RW_1;					// Read
		Wait1Cycle();
		LCD_E_1;
		Wait1Cycle();
//		LED_DIS;
		pbuf = LCD_DATA_PORT_IN;

#ifndef LCD_DATA_UPPBYTE
		pbuf <<= 4;
#endif

		Wait1Cycle();
		LCD_E_0;
		Wait1Cycle();
		LCD_E_1;					// b3-b0ǂݏo(dummy)
		Wait1Cycle();
		LCD_E_0;
//		Update();
		Wait1Cycle();
		LCD_RW_0;					// Write
	} while(pbuf & 0x80);			// TEST BF

	LCD_DATA_OUTPUT;				// LCD-DB output
}


//***********************************************
// BUSY`FbN
//	RET true:BUSY / false:not BUSY
//***********************************************
BYTE LCDBusyCheck(void) {
	BYTE pbuf;

	LCD_RS_0;
	Wait1Cycle();
	LCD_RW_1;							// Read
	Wait1Cycle();
	LCD_E_1;
	Wait1Cycle();
//	LED_DIS;

	LCD_DATA_INPUT;						// LCD-DB input
	pbuf = LCD_DATA_PORT_IN;			// b7-b3ǂݏo

#ifndef LCD_DATA_UPPBYTE
		pbuf <<= 4;
#endif

	LCD_E_0;
	Wait1Cycle();
	LCD_E_1;							// b3-b0ǂݏo(dummy)
	Wait1Cycle();
	LCD_E_0;
	Wait1Cycle();

	LCD_DATA_OUTPUT;					// LCD-DB output
//	Update();
	LCD_RW_0;							// Write

	return pbuf & 0x80;
}


//***********************************************
//J[\ړ(20x4sΉ)
//***********************************************
void LCDGotoXY(BYTE x, BYTE y) {
	switch(y) {
		case 1:
			x += 0x40;			// 2s
			break;
		case 2:
			x += 0x14;			// 3s
			break;
		case 3:
			x += 0x54;			// 4s
			break;
	}

	x |= 0x80;				// LCD address set command
	LCDWriteData(0, x);		// LCD WX^ZNg
}


//***********************************************
//\(NULLI[)
//***********************************************
void LCDString(char *str) {
	BYTE p = 0;

	while(str[p] != 0) {
		LCDWriteData(1, str[p]);
		p++;
	}
}
