//
// --------------------------------------------------------
// CQoŊ ĊwCANʐM
//   copyright(c) 2010 T.Nakao All rights reserved.
// --------------------------------------------------------
//
//	Prj002 N2(AVR)
//
//	09/01/16 AVR m[h2
//		for ATtiny2313 8MHz
//

#include <avr/io.h>

#define F_CPU 20000000UL			// 20MHz
#include <util/delay.h>
#include <stdio.h>

#include "..\\..\\Common\\2515Tag.h"
#include "..\\..\\Common\\2515Reg.h"

#include "..\2515SpiPort.h"
#include "..\\..\\Common\\CAN2515.c"
#include "..\IOPort.h"

#include "..\\CANMsg.h"

#define true 1
#define false 0

BYTE Flag1Sec = false;
BYTE SubCount;

char StrBuf[16];
BYTE MsgBuf[14];

BYTE LoopCnt = 0;
WORD count = 0;

BYTE LedStat = false;


// ----------------------------
// 
// ----------------------------
void UserInitialise() {
	// LED|[g̏
	ACSR |= (1<<ACD);				// AiORp[^OFF
	LED1_DDR |= (1<<LED1_BIT);
	LED2_DDR |= (1<<LED2_BIT);
	LED3_DDR |= (1<<LED3_BIT);

	LED1_ON;
	LED2_ON;
	LED3_ON;

	// CAN֌W  }XNAtB^ sgp
	CANInit(CAN_BRP_20MHz_125BPS);			// CLOCK 20MHz CAN 125bps

	CANSetFilterRxB0(3);			// RXB0ŃtB^A}XN͎gpȂ
	CANSetFilterRxB1(3);			// RXB1ŃtB^A}XN͎gpȂ

	CANSetOpMode(CAM_MODE_NORMAL);	// m[}E[h

	_delay_ms(200);
	LED1_OFF;
	LED2_OFF;
	LED3_OFF;

	_delay_ms(200);
	CANBitModCmd(BFPCTRL, (1<<B0BFS) | (1<<B0BFE), 1<<B0BFE);		// LED3 OFF
	_delay_ms(200);
	CANBitModCmd(BFPCTRL, (1<<B0BFS) | (1<<B0BFE), (1<<B0BFS) | (1<<B0BFE));		// LED3 ON
}


// ----------------------------
// C[v
// ----------------------------
void UserLoop() {
	WORD msg;
	struct tag_TXBnCTRL *pctrl;
	struct tag_TXBnDLC *pdlc;
	BYTE ctrl, dlc;
	BYTE rep;					// ԐMtO

	if(CANRxCheck(0)) {			// M`FbN
		// M
		MsgBuf[0] = CANReadReg(RXB0CTRL);

		CANRxB0Read(&MsgBuf[1], 0);			// bZ[Wo
		msg = ((WORD)MsgBuf[1] << 3);		// SIDH
		msg |= (MsgBuf[2] >> 5);			// SIDL

		// MbZ[W
		rep = false;					// ԐMtO
		switch(msg) {
			case MSG_N2_LED1_ON:
				LED1_ON;
				rep = true;				// ԐM
				msg = MSG_N1_LED1_ON;
				break;
			case MSG_N2_LED1_OFF:
				LED1_OFF;
				msg = MSG_N1_LED1_OFF;
				rep = true;				// ԐM
				break;
			case MSG_N2_LED2_ON:
				LED2_ON;
				msg = MSG_N1_LED2_ON;
				rep = true;				// ԐM
				break;
			case MSG_N2_LED2_OFF:
				LED2_OFF;
				msg = MSG_N1_LED2_OFF;
				rep = true;				// ԐM
				break;
		}

		// bZ[WԐM
		if(rep) {
			// ԐM
			rep = false;
			MsgBuf[1] = (BYTE)(msg >> 3);	// SIDH
			MsgBuf[2] = (BYTE)(msg << 5);	// SIDL
			MsgBuf[3] = 0;					// EID8
			MsgBuf[4] = 0;					// EID0

			// DLC
			dlc = 0;
			pdlc = (struct tag_TXBnDLC *)&dlc;
			pdlc->DLC = 0;					// f[^
			pdlc->RTR = 0;					// f[^Et[
			MsgBuf[5] = dlc;
			CANTxB0MsgWrite(&MsgBuf[1]);	// SPIR}h

			// MJn
			ctrl = 0;
			pctrl = (struct tag_TXBnCTRL *)&ctrl;
			pctrl->TXP = 0;					// Mobt@D揇
			pctrl->TXREQ = 1;					// Mv
			CANWriteReg(TXB0CTRL, ctrl);	// SPIR}h
		}
	}
}


int main(void) {
	UserInitialise();

	// C[v
	while(1) {
		UserLoop();
	}
}
