//
// --------------------------------------------------------
// CQoŊ ĊwCANʐM
//   copyright(c) 2010 T.Nakao All rights reserved.
// --------------------------------------------------------
//
//	Prj002 N1(AVR)
//
//	09/01/11 AVR m[h1
//		for ATmega168 20MHz
//


//#include <avr/interrupt.h>
#include <avr/io.h>
#include <stdio.h>

#define F_CPU 20000000UL			// 20MHz
#include <util/delay.h>

#include "..\\..\\Common\\2515Tag.h"
#include "..\\..\\Common\\2515Reg.h"

#include "2515SpiPort.h"
#include "..\\..\\Common\\CAN2515.c"
#include "IOPort.h"

#include "..\\CANMsg.h"

#define true 1
#define false 0

BYTE Flag1Sec = false;
BYTE SubCount;

char StrBuf[16];
BYTE MsgBuf[14];

BYTE LoopCnt = 0;
WORD count = 0;

BYTE LedStat = false;

// 荞݃[`
//ISR(TIMER0_OVF_vect) {
//
//	Flag1Sec = true;
//}


// ----------------------------
// 
// ----------------------------
void UserInitialise() {

	// LED|[g̏
	LED1_DDR |= (1<<LED1_BIT);
	LED2_DDR |= (1<<LED2_BIT);
	LED3_DDR |= (1<<LED3_BIT);

	LED1_ON;
	LED2_ON;
	LED3_ON;

	// 20MHz * 1/64 * 1/62500 = 5Hz
	// WGM13-10 = 0100, CS12-CS10 = 011
	// ClockSource 20MHz / 64, CTC[h
	TCCR1B |= ( (1<<WGM12) | (1<<CS11) | (1<<CS10) );
	//
	OCR1A = 62500;				// RyAl
	TCNT1 = 0;					// ^C}l
	TIFR1 &= ~(1<<OCF1A);		// 荞݃tONA


	// CAN֌W  }XNAtB^ sgp
	CANInit(CAN_BRP_20MHz_125BPS);			// CLOCK 20MHz CAN 125bps

	CANSetFilterRxB0(3);			// RXB0ŃtB^A}XN͎gpȂ
	CANSetFilterRxB1(3);			// RXB1ŃtB^A}XN͎gpȂ

	CANSetOpMode(CAM_MODE_NORMAL);	// m[}E[h

	_delay_ms(200);
	LED1_OFF;
	LED2_OFF;
	LED3_OFF;

	_delay_ms(200);
	CANBitModCmd(BFPCTRL, (1<<B0BFS) | (1<<B0BFE), 1<<B0BFE);		// LED3 OFF
	_delay_ms(200);
	CANBitModCmd(BFPCTRL, (1<<B0BFS) | (1<<B0BFE), (1<<B0BFS) | (1<<B0BFE));		// LED3 ON
}


// ----------------------------
// C[v
// ----------------------------
void UserLoop() {
	WORD msg;
	struct tag_TXBnCTRL *pctrl;
	struct tag_TXBnDLC *pdlc;
	BYTE ctrl, dlc;

	if(TIFR1 & 1<<OCF1A) {			// RyA}b`(5Hz)
		TIFR1 |= (1<<OCF1A);		// NA
		SubCount++;
		if(SubCount == 5) {
			SubCount = 0;
			Flag1Sec = true;
		}
	}

	if(Flag1Sec) {
		// 1sec
		Flag1Sec = false;

		switch(LoopCnt) {
			case 0:
				msg = MSG_N2_LED1_ON;
				break;
			case 1:
				msg = MSG_N2_LED1_OFF;
				break;
			case 2:
				msg = MSG_N2_LED2_ON;
				break;
			default:
				msg = MSG_N2_LED2_OFF;
				break;
		}
		LoopCnt = (LoopCnt + 1) % 4;

		// SID
		MsgBuf[1] = GET_SIDH(msg);		// SIDH
		MsgBuf[2] = GET_SIDL(msg);		// SIDL
		// MsgBuf[1] = (BYTE)(msg >> 3);	// SIDH
		// MsgBuf[2] = (BYTE)(msg << 5);	// SIDL
		MsgBuf[3] = 0;					// EID8
		MsgBuf[4] = 0;					// EID0

		// DLC
		dlc = 0;
		pdlc = (struct tag_TXBnDLC *)&dlc;
		pdlc->DLC = 0;					// f[^
		pdlc->RTR = 0;					// f[^Et[
		MsgBuf[5] = dlc;
		CANTxB0MsgWrite(&MsgBuf[1]);	// SPIR}h

		// MJn
		ctrl = 0;
		pctrl = (struct tag_TXBnCTRL *)&ctrl;
		pctrl->TXP = 0;					// Mobt@D揇
		pctrl->TXREQ = 1;				// Mv
		CANWriteReg(TXB0CTRL, ctrl);	// SPIR}h
	}


	// f[^M`FbN
	if(CANRxCheck(0)) {			// M`FbN
		// M

		MsgBuf[0] = CANReadReg(RXB0CTRL);
		CANRxB0Read(&MsgBuf[1], 0);
		msg = MAKE_SID(MsgBuf[1], MsgBuf[2]);
		// msg = (WORD)MsgBuf[1] << 8;		// SIDH
		// msg |= MsgBuf[2];				// SIDL
		// msg >>= 5;
		// MbZ[W
		switch(msg) {
			case MSG_N1_LED1_ON:
				LED1_ON;
				break;
			case MSG_N1_LED1_OFF:
				LED1_OFF;
				break;
			case MSG_N1_LED2_ON:
				LED2_ON;
				break;
			case MSG_N1_LED2_OFF:
				LED2_OFF;
				break;
		}
	}
}


int main(void) {
	UserInitialise();

	// C[v
	while(1) {
		UserLoop();
	}
}
